class PcProgressBar extends React.Component
{
  constructor(props)
  {
    super(props);
    this.state = {opacity:0, currentTime:props.time, currentWidth:0, currentLabelPosition:0, currentLabelAlign : "left"}
    this.tickVal = 10;
    this.label = React.createRef();
    this.lowTime = props.lowTime ? props.lowTime: -1; //when time is low
    this.currentColor = this.props.backgroundColor;
    PcDbg.log(CRASHDBG, `owner ${this.props.owner}`);
  }


  static craftProgressBar(my_ref, my_owner, b_auto_start, str_width_pc, str_height_pc, bgcolor, text_color, maxTime, lowTime, lowTimeColor, str_showDelay_s, on_tick_cb=null, onEndProgress_cb=null, bar_appearance_sound=null)
  {
    return e(PcProgressBar,
      {
        ref:my_ref,
        owner:my_owner,
        autoStart: b_auto_start,
        onTick: on_tick_cb?(n)=>on_tick_cb(n) : on_tick_cb /*null indeed*/,
        onEndProgress: onEndProgress_cb? ()=>onEndProgress_cb(): onEndProgress_cb /*null indeed*/,
        width: str_width_pc,// "100%",
        height: str_height_pc, // "5%",
        backgroundColor: bgcolor, // PcConfig.scenario.actionButtonBackgroundColor,
        textColor:text_color, //PcConfig.scenario.actionButtonTextColor,
        time:maxTime, // 10, 
        lowTime:lowTime, // 7,
        lowTimeColor: lowTimeColor,// "#FF0000",
        showDelay: str_showDelay_s, //"1s"
        barAppearanceSound: bar_appearance_sound
      }
    );
  }
  componentDidStuff()
  {
    //PcDbg.log(CRASHDBG, `owner ${this.props.owner}`);
    /*
    if (this.props.active)
    {
      this.stop();
      this.start();
    }
    */
  }

  componentDidMount()
  {
    this.componentDidStuff();
  }
  componentDidUpdate()
  {
    this.componentDidStuff();
  }
  start()
  {
    PcDbg.log(CRASHDBG, `owner ${this.props.owner}`);
    if (this.props.barAppearanceSound) {
        this.props.barAppearanceSound.play();
    }
    this.initCount();
  }

  stop()
  {
    this.resetCount();
    if (this.props.barAppearanceSound) {
      this.props.barAppearanceSound.stop();
    }
  }


  initCount()
  {
    this.interval = setInterval(()=>{this.doCount()}, this.tickVal);
    this.setState({opacity:1});
    this.playing = true;
  }

  resetCount()
  {
    clearInterval(this.interval);
    this.setState({opacity:0});
    this.playing = false;
    this.state.currentTime=this.props.time;
    this.state.currentWidth=0;
    this.state.currentLabelPosition=0;
    this.state.currentLabelAlign="left";
  }

  doCount()
  {
    PcDbg.log(false, `owner ${this.props.owner} time ${this.state.currentTime}`);
    if (this.props.onTick) this.props.onTick(this.maxTime - Math.ceil(this.state.currentTime));
    if (this.state.currentTime>0)
    {
      let t = this.state.currentTime-this.tickVal/1000;
      let p = (1-(t/this.props.time))*1920*PcConfig.renderSize;
      let align = "left";

      if (p-this.label.current.getWidth()>0)
      {
        p = p - this.label.current.getWidth();
        align = "right";
      }
      if (this.state.currentTime <= this.props.lowTime) {  
        if (this.props.lowTimeColor)    {
          this.currentColor = this.props.lowTimeColor;
        }
      } else {
        PcDbg.log(false, `set color ${this.props.backgroundColor}`);
        this.currentColor = this.props.backgroundColor;
      }
      this.setState(
        {
          currentTime:t,
          currentWidth:1-(t/this.props.time),
          currentLabelPosition:p,
          currentLabelAlign:align
        });

        this.label.current.updateLabel(Math.ceil(this.state.currentTime));

      this.forceUpdate();
      //clearInterval(this.interval);
    }
    else // temps écoulé
    {
        this.resetCount();
        if (this.props.onEndProgress) {
          this.props.onEndProgress();
        }
    }
  }

  render()
  {
    return e("div",
      {
        className:"pcprogressbar",
        style:
        {
          position:"absolute",
          width:this.props.width,
          height:this.props.height,
          opacity:this.state.opacity,
          transition: "opacity 0.25s ease-out"
        }
      },
      e("div",
      {
        className:"pcprogressbar-bg",
        style:
        {
          position:"absolute",
          width:"100%",
          height:"100%",
          backgroundColor:this.currentColor,
          opacity:0.5
        }
      }),
      e("div",
      {
        className:"pcprogressbar-fg",
        style:
        {
          position:"absolute",
          width:this.state.currentWidth*100 + "%",
          height:"100%",
          backgroundColor:this.currentColor,
          opacity:1
        }
      }),
      e(PcLabel,
      {
        ref:this.label,
        label:Math.ceil(this.state.currentTime) + "",
        x:this.state.currentLabelPosition,
        y:0,
        spacingH:20*PcConfig.renderSize,
        height:"100%",
        fontSize:PcConfig.scenario.fontSizeSmall,
        color: this.props.textColor,
        halign : this.state.currentLabelAlign,
        showDelay:"0,1s"
      })
    );
  }

}
