class PcScreenEnd extends PcScreen
{
  constructor(props)
  {
    super(props);
    this.label = React.createRef();
  }

  restart()
  {
    if (PcConfig.useElectron())
    {
      window.location = window.location.protocol + "" + window.location.host + "/" + window.location.pathname + "?lang=" + PcConfig.currentLanguage;
    }
    else {
      //window.location = window.location.protocol + "" + window.location.host + "/" + window.location.pathname + "?lang=" + PcConfig.currentLanguage;
      window.location.reload();
    }
  }

  render()
  {
    if (!this.props.active) return null;
    PcConfig._cleanPaymentCredit();
    var buttonLoading = e(PcButton,
      {
        label:PcConfig.screen.end.nextButton.title,
        onClick:()=>{},
        spacingV:50*PcConfig.renderSize,
        sound : PcConfig.sounds.buttonNext,
        fontColor:PcConfig.screen.end.nextButton.fontColor,
        borderColor:PcConfig.screen.end.nextButton.borderColor,
        backgroundColor:PcConfig.screen.end.nextButton.backgroundColor,
        showDelay:"0.4s",
        visibility:"hidden",
      }
    );

    var buttonLoaded = e(PcButton,
      {
        label:PcConfig.screen.end.nextButton.title,
        onClick:()=>{this.restart()},//this.props.goNextScreen,
        spacingV:50*PcConfig.renderSize,
        animated:true,
        sound : PcConfig.sounds.buttonNext,
        fontColor:PcConfig.screen.end.nextButton.fontColor,
        borderColor:PcConfig.screen.end.nextButton.borderColor,
        backgroundColor:PcConfig.screen.end.nextButton.backgroundColor,
        showDelay:"0.4s"
      }
    );

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.props.noAnimation?"":this.state.animationStyle
        },
      },
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"90%",
              height:"70%",
              top:"15%",
              left:"5%",
              display:"inline-flex",
              justifyContent: "center",
              flexWrap: "wrap",
              alignContent:"center",
            }
        },
        e(PcLabel,
          {
            ref:this.label,
            label:PcConfig.screen.end.title,
            position:"relative",
            width:"90%",
            height:this.props.height*(0.1),
            fontSize:PcConfig.scenario.fontSizeBig,
            color: PcConfig.scenario.fontColor,
            showDelay:"0,1s"
          }
        ),
        e('div', {style:{width:"100%", height:100*PcConfig.renderSize}}),
        this.props.endLoaded ? buttonLoaded : buttonLoading
      )
    );
  }
}
