class PcScreenPaymentConfirm extends PcScreen
{
    constructor(props)
    {
        super(props);
        this.nextScreenTimer = null;
    }
    async resetNextScreenTimer()
    {
      PcDbg.log(PAYMENTDBG, "entering");;
      await PcConfig.PHPLocalGetStatus("PcScreenPaymentConfig:resetNextScreenTimer", false, null); // immediate refresh memory PcConfig.cabin_status_xml.payment_credit
      this.nextScreenTimer = setTimeout(()=>this.onNextScreenTimer(), PcConfig.screen.paymentConfirm.displayTime);
      PcDbg.log(PAYMENTDBG, "exiting");;
    }
  
    onNextScreenTimer() 
    {        
        PcDbg.log(CRASHDBG, "entering. we should go to the format screen now");
        this.props.goNextScreen();
        PcDbg.log(CRASHDBG,  "exiting");                
    }
 
  async  componentDidUpdate() // this runs everytime a component is updated (props from caller sstate) 
  {
    PcDbg.log(PAYMENTDBG, "pre-entering");
    if (!this.props.active) return;
    PcDbg.log(PAYMENTDBG, "entering");
    // refresh PcConfig.cabin_xml.payment_credit to reflect 1 credit is served
    await PcConfig.PHPLocalGetStatus("PcScreenPaymentConfirm::ComponentDidUpdate", false, null);
    await this.resetNextScreenTimer();
    PcDbg.log(PAYMENTDBG, "exiting");
  
  }
  render()
  {
    PcDbg.log(PAYMENTDBG, "entering");;
    if (!this.props.active) return null;
    // play credit confirm sound
    PcConfig.sounds.paymentConfirm.play(); // fixme: creates DOMexceptions

    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.state.animationStyle
        },
      },
        e('div',
        {
          style:
          {
            position:"absolute",
            width:this.props.width*0.9,
            height:this.props.height*0.2,
            left:this.props.width*0.05,
            top:this.props.height*(PcConfig.screen.paymentConfirm.titlePosition=="top" ? 0.05 : (PcConfig.screen.paymentConfirm.titlePosition=="bottom" ? 0.75 : 0.4)),
          }
        },
          e(PcLabel,
            {
              label:PcConfig.screen.paymentConfirm.title,
              title:true,
              width:this.props.width*0.9,
              height:this.props.height*0.2,
              x:0,
              y:0,
              fontSize:PcConfig.scenario.fontSizeGiant,
              color:PcConfig.screen.intro.titleColor,
              valign:PcConfig.screen.paymentConfirm.titlePosition,
              noAnimation:true,
              showDelay:"0.1s"
            }
          )
        )
    );
  }
}
