class PcScreenTemplateAndFilter extends PcScreen
{
  constructor(props)
  {
    super(props);

    this.buttons = [];
    this.buttons["previous"] = React.createRef();
    this.buttons["next"] = React.createRef();

    this.registerButton(this.buttons["previous"], PcConfig.screen.templateAndFilter.previousButton.title);
    this.registerButton(this.buttons["next"], PcConfig.screen.templateAndFilter.nextButton.title);
  }
  goPrevScreen()
  {
    super.onEndProgress();
    this.props.goPrevScreen();
  }
  onEndProgress(x) //derived
  {
    PcConfig.sounds.buttonNext.play(); 
    super.onEndProgress(x); // stop the bar if any
    PcDbg.log(CRASHDBG, `SCREENTEMPLATEANDFILTER SECIFIC enter as ${this.constructor["name"]}`);
    this.props.goNextScreen();
  }

  normalizeButtons()
  {
    setTimeout(()=>{this.normalizeButtonsWidth()}, 10);
  }

  componentDidStuff()
  {
      if (this.props.active) {
        super.componentDidStuff();
        this.normalizeButtons();
      }
  }

  componentDidMount()
  {
    this.componentDidStuff();
  }
  componentDidUpdate()
  {
    this.componentDidStuff()
  }

  render()
  {
    if (!this.props.active) return null;

    let skins;

    if (PcConfig.getMemory("winner")==1)
    {
      skins = PcConfig.instantWin.lots[PcConfig.getMemory("winnerLot")];
    }
    else {
      skins = PcConfig.screen.templateAndFilter.skins;
    }

    let framingAlert = PcFormErrorMessage.OK.str_msg;
    let framingAlertDesc = PcFormErrorMessage.OK.str_msg;;

    if (PcConfig.framingAlert.length>0)
    {
      framingAlert = PcConfig.framingAlert[0];

      framingAlertDesc = PcConfig.screen.templateAndFilter.framingText1 + "\n";

      switch (framingAlert)
      {
        case "face" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextFace; break;
        case "size" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextSize; break;
        case "up" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextUp; break;
        case "down" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextDown; break;
        case "right" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextLeft; break;
        case "left" : framingAlertDesc += PcConfig.screen.templateAndFilter.framingTextRight; break;
      }

      framingAlertDesc += "\n\n" + PcConfig.screen.templateAndFilter.framingText2;
    }

      
    let candidate_label_button_previous;
    let candidate_show_button_previous;
    let label_button_previous;
    let show_button_previous;

    if (PcConfig.scenario.payment.active) {
      
      if (this.props.shootAttemptCount < PcConfig.screen.templateAndFilter.payment.maxShootAttempts) { // still some attempts? 
        candidate_show_button_previous = true;
        if (this.props.shootAttemptCount == PcConfig.screen.templateAndFilter.payment.maxShootAttempts -1 ) { // warn that this will be the last attempt (2/3 -> previous -> 3/3)
          candidate_label_button_previous = PcConfig.screen.templateAndFilter.payment.labelPreviousButtonFinalAttempt;
        } else { // next attempt (1/3 -> previous -> 2/3)
          candidate_label_button_previous = PcConfig.screen.templateAndFilter.payment.labelPreviousButtonNextAttempt;
        }
      } else { // no more attempts possible (3->3 -> no previous button )
        candidate_show_button_previous = false;
      }

    } else {
      candidate_show_button_previous = true;
      candidate_label_button_previous = PcConfig.screen.templateAndFilter.previousButton.title;
    }
    show_button_previous = candidate_show_button_previous || framingAlert !=PcFormErrorMessage.OK.str_msg; // if there is a framing alert, show previous button too
    label_button_previous = framingAlert != PcFormErrorMessage.OK.str_msg ?  PcConfig.screen.templateAndFilter.framingButtonLabel : candidate_label_button_previous;

    let button_previous = null;
    if (show_button_previous){
      button_previous =  e(PcButton,
        {
          ref:this.buttons["previous"],
          label:label_button_previous,
          fontColor:PcConfig.screen.templateAndFilter.previousButton.fontColor,
          borderColor:PcConfig.screen.templateAndFilter.previousButton.borderColor,
          backgroundColor:PcConfig.screen.templateAndFilter.previousButton.backgroundColor,
          prevArrow:true,
          align:"right",
          onClick:(x)=>{this.goPrevScreen();},
          sound : PcConfig.sounds.buttonPrevious,
          showDelay:"0.3s"
        }
      );
    } 
    let main_label_y = this.props.height*(PcMode.screen.templateAndFilter.titleY);
    let main_label_h =  framingAlert != PcFormErrorMessage.OK.str_msg ? this.props.height*0.4 : this.props.height*0.1;
    return e('div',
      {
        className:this.state.className,
        index:this.props.index,
        style:
        {
          display: (this.props.active ? 'block' : 'none'),
          fontFamily:PcConfig.scenario.fontFamily,
          animation:this.props.noAnimation?"":this.state.animationStyle
        },
        onClick:()=>{this.onClick();}, /* allows this screen to listen to clicks and do stuff (for pre-bar timer and progress bar, for example) */
        /*onMouseMove:()=>{this.onClick();},*/
        onTouchEnd:()=>{this.onClick();},
      },
      this.bar, // fixme adjust me in layout
      e(PcLabel,
        {
          label: framingAlert != PcFormErrorMessage.OK.str_msg ? framingAlertDesc : ( PcConfig.getMemory("winner")==1 ? PcConfig.instantWin.title : PcConfig.screen.templateAndFilter.title ),
          title:true,
          width:this.props.width*0.9,
          height:main_label_h,
          x:this.props.width*0.05,
          y:main_label_y,
          fontSize:PcConfig.scenario.fontSizeBig,
          color: PcConfig.scenario.fontColor,
          showDelay:"0,1s",
        }
      ),
      (framingAlert != PcFormErrorMessage.OK.str_msg) ? null : e(PcSliderTemplateAndFilter,
        {
          active: this.props.active,
          keepState: this.props.keepState,
          name:"templateandfilter",
          format:PcConfig.getMemory("currentFormat"),
          formatIndex:PcConfig.getMemory("currentFormatIndex"),
          filters:PcConfig.screen.templateAndFilter.filters,
          skins:skins,
          onSelectSlide:()=>{this.onEndProgress();},
          x:0,
          y:this.props.height*(PcMode.screen.templateAndFilter.sliderY),
          width:this.props.width,
          height:this.props.height*(PcMode.screen.templateAndFilter.sliderH),
          showDelay:"0.2s",
          rbg_label_y_offset:main_label_y + main_label_h
        }
      ),
      e('div',
        {
          style:
            {
              position:"absolute",
              width:"100%",
              top:this.props.height * (PcMode.screen.templateAndFilter.buttonsY),
              display:"inline-flex",
              justifyContent: "space-evenly"
            }
        },
        button_previous,
      
        (framingAlert != PcFormErrorMessage.OK.str_msg) ? null : e(PcButton,
          {
            ref:this.buttons["next"],
            label: PcConfig.screen.templateAndFilter.nextButton.title,
            fontColor:PcConfig.screen.templateAndFilter.nextButton.fontColor,
            borderColor:PcConfig.screen.templateAndFilter.nextButton.borderColor,
            backgroundColor:PcConfig.screen.templateAndFilter.nextButton.backgroundColor,
            nextArrow:true,
            animated:true,
            kind: "action",
            onClick:(x)=>{this.onEndProgress();},
            sound : PcConfig.sounds.buttonNext,
            showDelay:"0.4s"
          }
        )
      )
    );
  }
}
