
ONE_MINUTE_IN_SECONDS = 60
ONE_HOUR_IN_SECONDS = ONE_MINUTE_IN_SECONDS * 60
ONE_DAY_IN_SECONDS = ONE_HOUR_IN_SECONDS * 24
ONE_MONTH_IN_SECONDS = 30 * ONE_DAY_IN_SECONDS
MORESQLDBG = True
from time import perf_counter
import sys
import platform
import subprocess
import mysql.connector
def fdbg(fn, doit, *args):
    if not doit:
        return
    fh = open(fn, 'a')
    s = _dbg(*args)
    fh.write(s)
    dbg(doit, *args)

def dbg(doit, *args):
    if not doit:
        return
    s = _dbg(*args)
    sys.stderr.write((s))

def _dbg(*args): 
    import inspect
    import logging
    logger = logging.getLogger('root')
    logger.setLevel(logging.DEBUG)
    string=' '.join(map(str,args))
    # Get the previous frame in the stack, otherwise it would
    # be THIS function!
    func = inspect.currentframe().f_back.f_back.f_code
    # Dump the message + the name of this function to the log.
    my_str = "%-48s %-20s\n" % (func.co_name + "():" + str(func.co_firstlineno) + ": ", string)
    return my_str


def get_time():
    return perf_counter()


def is_windows():
	is_w = False
	p = platform.system().lower()
	print(p)
	if p == "windows" or p.startswith("cygwin"):
		is_w = True
	return is_w

def my_ping(sHost) -> bool:
    try:
        subprocess.check_output("ping -{} 1 {}".format(("c","n")[is_windows()], sHost), shell=True)
        r = True
    except Exception as ex:
        dbg(True, f"exception, {ex}")
        r = False
    # dbg(True, f"returns {r}")	
    return r

def _sql_exec(sql, commit=False):
    dbg(MORESQLDBG, "entering with sql " + sql)


    '''
    this is suboptimal but whatever. we cannot keep a self.mydb connection as it can be accessed from multiple subprocesses and this is not playing nicely.
    see this error:
        Process ForkPoolWorker-1:
        Traceback (most recent call last):
        File "/usr/lib/python3.9/multiprocessing/process.py", line 315, in _bootstrap
            self.run()
        File "/usr/lib/python3.9/multiprocessing/process.py", line 108, in run
            self._target(*self._args, **self._kwargs)
        File "/usr/lib/python3.9/multiprocessing/pool.py", line 114, in worker
            task = get()
        File "/usr/lib/python3.9/multiprocessing/queues.py", line 368, in get
            return _ForkingPickler.loads(res)
        File "/usr/lib/python3.9/multiprocessing/reduction.py", line 246, in _rebuild_socket
            fd = df.detach()
        File "/usr/lib/python3.9/multiprocessing/resource_sharer.py", line 58, in detach
            return reduction.recv_handle(conn)
        File "/usr/lib/python3.9/multiprocessing/reduction.py", line 189, in recv_handle
            return recvfds(s, 1)[0]
        File "/usr/lib/python3.9/multiprocessing/reduction.py", line 164, in recvfds
            raise RuntimeError('received %d items of ancdata' %

    '''
    mydb = mysql.connector.connect(
        host="localhost",
        user="root",
        password="",
        database="photocabine",
        charset ='ascii' )

    sql_escaped = sql
    # sql_escaped = mydb.converter.escape(sql)
    # dbg(MORESQLDBG, f"escaped sql is {sql_escaped}")
    c = mydb.cursor(buffered=True, dictionary=True)  # burffered so that all select lines are prefetched, allowing to immediately do updates from results from a select: https://stackoverflow.com/questions/29772337/python-mysql-connector-unread-result-found-when-using-fetchone            
    c.execute(sql_escaped)
    if commit:
        mydb.commit()
    dbg(False, "exiting with cursor "+ str(c))
    return c

def create_set_line(my_dict):
    s = ""
    pref =""
    i=0
    for (k,v) in my_dict.items():
        my_v = v
        if v is None:
            my_v ="NULL"
        elif type(v) is str: 
            my_v = f"'{my_v}'" 
        s += pref+ f"{k}={my_v}"
        if i==0:
            pref = ", "
    return s



