if 0:
    from ctypes import cdll, c_void_p, c_int32, cast, c_char_p, c_wchar_p
    from sys import version_info

    xunicode = str if version_info[0] > 2 else eval("unicode")

    # If running under Cygwin Python, just use DLL name
    # If running under non-Cygwin Windows Python, use full path to cygwin1.dll
    # Note Python and cygwin1.dll must match bitness (i.e. 32-bit Python must
    # use 32-bit cygwin1.dll, 64-bit Python must use 64-bit cygwin1.dll.)
    cygwin = cdll.LoadLibrary("cygwin1.dll")
    cygwin_create_path = cygwin.cygwin_create_path
    cygwin_create_path.restype = c_void_p
    cygwin_create_path.argtypes = [c_int32, c_void_p]

    print("0")
    # Initialise the cygwin DLL. This step should only be done if using
    # non-Cygwin Python. If you are using Cygwin Python don't do this because
    # it has already been done for you.
    cygwin_dll_init = cygwin.cygwin_dll_init
    cygwin_dll_init.restype = None
    cygwin_dll_init.argtypes = []
    print("A")
    cygwin_dll_init()
    print("1")
    free = cygwin.free
    free.restype = None
    free.argtypes = [c_void_p]

    CCP_POSIX_TO_WIN_A = 0
    CCP_POSIX_TO_WIN_W = 1
    CCP_WIN_A_TO_POSIX = 2
    CCP_WIN_W_TO_POSIX = 3

    def win2posix(path):
        """Convert a Windows path to a Cygwin path"""
        result = cygwin_create_path(CCP_WIN_W_TO_POSIX,xunicode(path))
        if result is None:
            raise Exception("cygwin_create_path failed")
        value = cast(result,c_char_p).value
        free(result)
        return value

    def posix2win(path):
        """Convert a Cygwin path to a Windows path"""
        result = cygwin_create_path(CCP_POSIX_TO_WIN_W,str(path))
        if result is None:
            raise Exception("cygwin_create_path failed")
        value = cast(result,c_wchar_p).value
        free(result)
        return value

import re
#from os import environ
def win_path(path):
    match = re.match('(/(cygdrive/)?)(.*)', path)
    if not match:
        return path.replace('/', '\\')
    dirs = match.group(3).split('/')
    dirs[0] = f'{dirs[0].upper()}:'
    return '\\'.join(dirs)
# Example, convert LOCALAPPDATA to cygwin path and back
# localAppData = "/cygdrive/c/tamere.exe"
# print ("B")
# from os import environ

#localAppData = environ["LOCALAPPDATA"]
#print("Original cygwin path: %s" % localAppData)
#localAppData = win_path(localAppData)
#print("Win32 path: %s" % localAppData)

