<?php
define('DRY_RUN_SELECT' , false);
define('DRY_RUN_UPDATE', false);
define('DRY_RUN_DELETE', false);
define('DRY_RUN_INSERT', false);
define('DRY_RUN_QUERY', false);

const SQLDBG = false;
const SQL_DRY_RUN_LOG = false;
const SQL_UPDATE_DBG = false;
const SQL_SELECT_DBG = false;
const SQL_DELETE_DBG = false;
const SQL_QUERY_DBG = false;
const SQL_INSERT_DBG = false;
const SQL_ALL_DBG = false;


function protect_string_in_array($inp) { 

	if(is_array($inp)) 
		return array_map(__METHOD__, $inp); 

	if(!empty($inp) && is_string($inp)) { 
		return "'" . str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $inp) . "'";
	} 

	return $inp; 
} 

function drdbg($log)
{
	dbg(SQL_DRY_RUN_LOG, "DRY_RUN: $log");
}

function my_select($db, $sql) # only one item
{
	$ret = [];
    dbg(SQL_SELECT_DBG|SQL_ALL_DBG, $sql);
	if (DRY_RUN_SELECT)
	{
		//var_dump($db);
        drdbg("db select one");
	}
	else
	{
		$ret = $db->select($sql);
	}

	return $ret;

}
function my_selectAll($db, $sql) #returns all items
{
	$ret = [];
    dbg(SQL_SELECT_DBG|SQL_ALL_DBG, $sql);
	if (DRY_RUN_SELECT)
	{
        drdbg("db selectAll");
	}
	else
	{
		$ret = $db->selectAll($sql);
	}

	return $ret;
}


function my_query($db, $sql)
{
	$ret = NULL;
    dbg(SQL_QUERY_DBG|SQL_ALL_DBG, $sql);
	if (DRY_RUN_QUERY)
	{
		drdbg("db query $sql");
	}
	else
	{
		$ret = $db->query($sql);
	}
	return $ret;
}

function my_update($db, $table, $changes_array, $where)
{
	$ret = "";
    dbg(SQLDBG, "db update " . $table . " " . json_encode($changes_array) . " where " . $where);
	if (DRY_RUN_UPDATE)
	{
        drdbg("db update");
	}
	else
	{
		$ret = $db->update($table, $changes_array, $where);
	}
	return $ret;
}
function my_delete($db, $table, $where) 
{
	$ret = "";
    dbg(SQL_DELETE_DBG|SQL_ALL_DBG, "db delete from " . $table . " where " . $where);
	if (DRY_RUN_DELETE)
	{
        drdbg("db delete");
	}
	else
	{
		$ret = $db->delete($table, $where);
	}
	return $ret;
}


function my_insert($db, $table, $insert_assoc_array) 
{
	$ret = "";
    dbg(SQL_INSERT_DBG|SQL_ALL_DBG, "db insert in base " . $db->getBase() . " table: " . $table . " fields/values: " . json_encode($insert_assoc_array));
	if (DRY_RUN_INSERT)
	{
        drdbg("db insert");
	}
	else
	{
		$ret = $db->insert($table, $insert_assoc_array);
	}
	return $ret;
}

 ?>
 
