<?php
//CABIN + PHP SERVER SCRIPT, TO DAEMONIZE WITH PYTHON
include_once 'config.php' ;
define('LOCALUPDBG', true);
$bServerReachable = is_server_reachable() ;
// select photocabine_status line with device id and config id
$oConfigXml = simplexml_load_file(getXmlFile('config.xml')) ;

function checkDSLRExists()
{
    $exists = false;
    $cmd = "PATH=C:\\cygwin64\\bin;%PATH% && bash -c \"lsusb | egrep Nikon | head -1 | awk '{print $6}' | xargs echo -n \"" ; 
	$stdout = null;
    // yes, head -1 ! sometimes lsusb sees dups, see bug #30 !
	exec($cmd, $stdout);
	dbg(LOCALUPDBG, json_encode($stdout));
	$stdout_line_0 = sizeof($stdout) > 0?  $stdout[0] : "nothing";
	switch($stdout_line_0) 
	{
		case "04b0:0438": //NIKON D5500
		case "04b0:043f": //NIKON D5600
			$exists = true; 
		break;
		default:
			break;
	}

	dbg(LOCALUPDBG, "exists is " . json_encode($exists));
	return $exists;
  }

function useDSLR()
{
	global $oConfigXml;
	$useWebCam = $oConfigXml->general->configuration->useWebcam;
	$ret = ! $useWebCam;
	dbg(LOCALUPDBG, "useWebCam? " . $useWebCam . " ret: " . json_encode($ret));
	return $ret;
}

function checkCabinSanity($line)
{
	global $oConfigXml;
	$ret = false;
	$payment_active = $oConfigXml->general->payment->active;
	dbg(LOCALUPDBG, "entering " . $payment_active);
	switch($payment_active) {
		case false:
			$ret = true;
			break;
		case true:
			$printer_valid_statuses = array("Idle", "Standby", "Printing");
			$ept_error_code = $line->ept_error_code;
			$printer_status = $line->printer_status;
			$printer_photos_remaining = $line->printer_photos_remaining;
			$payment_credit = $line->payment_credit;
			$is_printer_status_valid = in_array($printer_status, $printer_valid_statuses);
			$is_camera_valid = (! useDSLR()) || checkDSLRExists(); 
			$cond_general = ($is_camera_valid && $printer_photos_remaining >= 4 && $is_printer_status_valid);

			$ret = $cond_general && (($payment_credit != 0) ||  ($ept_error_code == 0));
			dbg(LOCALUPDBG, "=> ret: " . json_encode($ret) . " because: 
			cond_general: $cond_general ept_error_code: $ept_error_code printer_status: $printer_status 
			photos_remaining: $printer_photos_remaining is_camera_valid $is_camera_valid 
			payment_credit $payment_credit ept_error_code $ept_error_code"); 
			break;
	}
	dbg(LOCALUPDBG, "ret is " . json_encode($ret));
	return $ret;
}

$sql  = 'SELECT * from photocabine_status WHERE (config = \''. $oConfigXml->id . '\' AND device = ' . DEVICE_ID . ') ORDER BY date DESC LIMIT 0, 1';

dbg(LOCALUPDBG, "initial req: $sql");
$line = $db->select($sql);
dbg(LOCALUPDBG, "initial req done " . json_encode($line));
if (! $line) // create the cabin status entry
{
	$data = array();
	$data['date'] = date('Y-m-d H:i:s');
	$my_date = $data['date'];
	$data['config'] = $oConfigXml->id;
	$data['device'] = DEVICE_ID;
	$data['needs_reboot'] = 0;
	$data['cabin_is_sane'] = 0;
	$db->insert('photocabine_status', $data);
}
else
{
	$my_date = $line->date;
}
//common part
$data['is_server_reachable'] = $bServerReachable;
$data['cabin_is_sane'] = checkCabinSanity($line); 
$statePrinter = checkPrinterState() ;
if ($statePrinter)
{ // update printer status
	dbg(LOCALUPDBG, "printer state is: " . json_encode($statePrinter) . " relevant vars: " . $statePrinter->status . " and " . $statePrinter->counter);
	$data['printer_status'] = $statePrinter->status;
	$data['printer_photos_remaining'] = $statePrinter->counter;
}
$get_vars = [ "needs_reboot", "payment_credit" ]; // this script is called by cabin local JS code just to clean 'needs_reboot' or 'payment_credit' fields
foreach ($get_vars as $get_var) {
	if (array_key_exists($get_var, $_GET)) {
		$data[$get_var] = (int) getParam($get_var, $_GET, 0) ;
	}
}
$datastr = json_encode($data);
dbg(LOCALUPDBG, "update req with data $datastr");
$db->update('photocabine_status', $data, '(date = \'' . $my_date . '\' AND device = ' . DEVICE_ID . ' AND config = \'' . $oConfigXml->id . '\' )');
dbg(LOCALUPDBG, "update req done");

			
?>
